Package: cascadeSelect
Title: A Cascade Select Input for 'Shiny'
Version: 1.1.0
Authors@R: c(
    person("Stéphane", "Laurent", , "laurent_step@outlook.fr", role = c("aut", "cre")),
    person("PrimeTek", "Informatics", role = "cph",
           comment = "PrimeReact library")
  )
Description: Provides a cascade select widget for usage in 'Shiny'
    applications. This is useful for selection of hierarchical choices
    (e.g. continent, country, city). It is taken from the 'JavaScript'
    library 'PrimeReact'.
License: GPL-3
Depends: R (>= 2.10)
Imports: fontawesome, grDevices, htmltools, reactR, shiny, tools
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.2.3
URL: https://github.com/stla/cascadeSelect
BugReports: https://github.com/stla/cascadeSelect/issues
NeedsCompilation: no
Packaged: 2023-06-15 05:33:55 UTC; SDL96354
Author: Stéphane Laurent [aut, cre],
  PrimeTek Informatics [cph] (PrimeReact library)
Maintainer: Stéphane Laurent <laurent_step@outlook.fr>
Repository: CRAN
Date/Publication: 2023-06-15 06:00:02 UTC
Built: R 4.6.0; ; 2026-04-28 15:16:08 UTC; unix

# cascadeSelect

<!-- badges: start -->
[![R-CMD-check](https://github.com/stla/cascadeSelect/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/stla/cascadeSelect/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

___

![](https://raw.githubusercontent.com/stla/cascadeSelect/main/inst/gifs/essai01.gif)

countries <- list(

  list(
    name = "Australia",
    states = list(
      list(
        name = "New South Wales",
        cities = list(
          list(
            cname = "Sydney", code = "A-SY"
          ),
          list(
            cname = "Newcastle", code = "A-NE"
          ),
          list(
            cname = "Wollongong", code = "A-WO"
          )
        )
      ),
      list(
        name = "Queensland",
        cities = list(
          list(
            cname = "Brisbane", code = "A-BR"
          ),
          list(
            cname = "Townsville", code = "A-TO"
          )
        )
      )
    )
  ),

  list(
    name = "Canada",
    states = list(
      list(
        name = "Quebec",
        cities = list(
          list(
            cname = "Montreal", code = "C-MO"
          ),
          list(
            cname = "Quebec City", code = "C-QU"
          )
        )
      ),
      list(
        name = "Ontario",
        cities = list(
          list(
            cname = "Ottawa", code = "C-OT"
          ),
          list(
            cname = "Toronto", code = "C-TO"
          )
        )
      )
    )
  ),

  list(
    name = "United states",
    states = list(
      list(
        name = "California",
        cities = list(
          list(
            cname = "Los Angeles", code = "US-LA"
          ),
          list(
            cname = "San Diego", code = "US-SD"
          ),
          list(
            cname = "San Francisco", code = "US-SF"
          )
        )
      ),
      list(
        name = "Florida",
        cities = list(
          list(
            cname = "Jacksonville", code = "US-JA"
          ),
          list(
            cname = "Miami", code = "US-MI"
          ),
          list(
            cname = "Tampa", code = "US-TA"
          ),
          list(
            cname = "Orlando", code = "US-OR"
          )
        )
      ),
      list(
        name = "Texas",
        cities = list(
          list(
            cname = "Austin", code = "US-AU"
          ),
          list(
            cname = "Dallas", code = "US-DA"
          ),
          list(
            cname = "Houston", code = "US-HO"
          )
        )
      )
    )
  )
)

library(cascadeSelect)

folder <- list(
  list( # first folder
    name = "bootstrap", icon = Icon("oi oi-markdown", color = "purple", scale=2),
    subfolders = list(
      list( # subfolder of the first folder
        name = "css", icon = Icon("oi oi-json", color = "orange"),
        files = list(
          list(
            fname = "bootstrap-theme.css", size = "25 KB",
            icon = Icon("bi bi-filetype-css", color = "steelblue")
          ),
          list(
            fname = "bootstrap.css", size = "142 KB",
            icon = Icon("bi bi-filetype-css", color = "steelblue")
          )
        )
      ),
      list( # subfolder of the first folder
        name = "js", icon = Icon("bi bi-folder-fill", color = "orange"),
        files = list(
          list(
            fname = "bootstrap.js", size = "74 KB",
            icon = Icon("bi bi-filetype-js", color = "yellow")
          ),
          list(
            fname = "npm.js", size = "484 B",
            icon = Icon("bi bi-filetype-js", color = "yellow")
          )
        )
      )
    )
  ),
  list( # second folder
    name = "datatables", icon = Icon("bi bi-table", color = "purple"),
    subfolders = list(
      list( # subfolder of the second folder
        name = "css", icon = Icon("bi bi-folder-fill", color = "orange"),
        files = list(
          list(
            fname = "dataTables.bootstrap.css", size = "7.5 KB",
            icon = Icon("bi bi-filetype-css", color = "steelblue")
          ),
          list(
            fname = "dataTables.extra.css", size = "1.2 KB",
            icon = Icon("bi bi-filetype-css", color = "steelblue")
          )
        )
      ),
      list( # subfolder of the second folder
        name = "js", icon = Icon("bi bi-folder-fill", color = "orange"),
        files = list(
          list(
            fname = "dataTables.bootstrap.js", size = "4.2 KB",
            icon = Icon("bi bi-filetype-js", color = "yellow")
          ),
          list(
            fname = "jquerydataTable.min.js", size = "77.1 KB",
            icon = Icon("bi bi-filetype-js", color = "yellow")
          )
        )
      )
    )
  ),
  list( # third folder
    name = "shiny_scss", icon = Icon("bi bi-folder-fill", color = "orange"),
    subfolders = list(
      list(
        fname = "bootstrap.scss", size = "2.7 KB",
        icon = Icon("bi bi-filetype-scss", color = "salmon")
      ),
      list(
        fname = "shiny.scss", size = "10.1 KB",
        icon = Icon("bi bi-filetype-scss", color = "salmon")
      )
    )
  )
)

library(shiny)
library(cascadeSelect)

ui <- fluidPage(
  titlePanel("Cascade Select"),
  fluidRow(
    column(
      6,
      cascadeSelectInput(
        "cascade",
        choices = folder,
        placeholder = "Select a file",
        optionLabel = "fname",
        optionGroupLabel = "name",
        optionGroupChildren = list("subfolders", "files"), # (sub, subsub)
        theme = "lara-dark-blue"
      ),
      br(),br(),
      textOutput("textOutput")
    )
  )
)

server <- function(input, output, session) {
  output[["textOutput"]] <- renderText({
    choice <- input[["cascade"]]
    sprintf(
      "You selected the file: %s.\nIts size is: %s.",
      choice[["fname"]], choice[["size"]]
    )
  })
}

shinyApp(ui, server)

pi_icons <- c(
  "align-center",
  "align-justify",
  "align-left",
  "align-right",
  "android",
  "angle-double-down",
  "angle-double-left",
  "angle-double-right",
  "angle-double-up",
  "angle-down",
  "angle-left",
  "angle-right",
  "angle-up",
  "apple",
  "arrow-circle-down",
  "arrow-circle-left",
  "arrow-circle-right",
  "arrow-circle-up",
  "arrow-down-left",
  "arrow-down-right",
  "arrow-down",
  "arrow-left",
  "arrow-right-arrow-left",
  "arrow-right",
  "arrows-alt",
  "arrows-h",
  "arrows-v",
  "arrow-up-left",
  "arrow-up-right",
  "arrow-up",
  "at",
  "backward",
  "ban",
  "bars",
  "bell",
  "bitcoin",
  "bolt",
  "bookmark-fill",
  "bookmark",
  "book",
  "box",
  "briefcase",
  "building",
  "calculator",
  "calendar-minus",
  "calendar-plus",
  "calendar",
  "calendar-times",
  "camera",
  "caret-down",
  "caret-left",
  "caret-right",
  "caret-up",
  "car",
  "cart-plus",
  "chart-bar",
  "chart-line",
  "chart-pie",
  "check-circle",
  "check-square",
  "check",
  "chevron-circle-down",
  "chevron-circle-left",
  "chevron-circle-right",
  "chevron-circle-up",
  "chevron-down",
  "chevron-left",
  "chevron-right",
  "chevron-up",
  "circle-fill",
  "circle-off",
  "circle-on",
  "circle",
  "clock",
  "clone",
  "cloud-download",
  "cloud",
  "cloud-upload",
  "code",
  "cog",
  "comments",
  "comment",
  "compass",
  "copy",
  "credit-card",
  "database",
  "delete-left",
  "desktop",
  "directions-alt",
  "directions",
  "discord",
  "dollar",
  "download",
  "eject",
  "ellipsis-h",
  "ellipsis-v",
  "envelope",
  "eraser",
  "euro",
  "exclamation-circle",
  "exclamation-triangle",
  "external-link",
  "eye-slash",
  "eye",
  "facebook",
  "fast-backward",
  "fast-forward",
  "file-edit",
  "file-excel",
  "file-export",
  "file-import",
  "file-o",
  "file-pdf",
  "file",
  "file-word",
  "filter-fill",
  "filter-slash",
  "filter",
  "flag-fill",
  "flag",
  "folder-open",
  "folder",
  "forward",
  "gift",
  "github",
  "globe",
  "google",
  "hashtag",
  "heart-fill",
  "heart",
  "history",
  "home",
  "hourglass",
  "id-card",
  "images",
  "image",
  "inbox",
  "info-circle",
  "info",
  "instagram",
  "key",
  "language",
  "linkedin",
  "link",
  "list",
  "lock-open",
  "lock",
  "map-marker",
  "map",
  "megaphone",
  "microphone",
  "microsoft",
  "minus-circle",
  "minus",
  "mobile",
  "money-bill",
  "moon",
  "palette",
  "paperclip",
  "pause",
  "paypal",
  "pencil",
  "percentage",
  "phone",
  "play",
  "plus-circle",
  "plus",
  "pound",
  "power-off",
  "prime",
  "print",
  "qrcode",
  "question-circle",
  "question",
  "reddit",
  "refresh",
  "replay",
  "reply",
  "save",
  "search-minus",
  "search-plus",
  "search",
  "send",
  "server",
  "share-alt",
  "shield",
  "shopping-bag",
  "shopping-cart",
  "sign-in",
  "sign-out",
  "sitemap",
  "slack",
  "sliders-h",
  "sliders-v",
  "sort-alpha-alt-down",
  "sort-alpha-alt-up",
  "sort-alpha-down",
  "sort-alpha-up",
  "sort-alt-slash",
  "sort-alt",
  "sort-amount-down-alt",
  "sort-amount-down",
  "sort-amount-up-alt",
  "sort-amount-up",
  "sort-down",
  "sort-numeric-alt-down",
  "sort-numeric-alt-up",
  "sort-numeric-down",
  "sort-numeric-up",
  "sort",
  "sort-up",
  "spinner",
  "star-fill",
  "star",
  "step-backward-alt",
  "step-backward",
  "step-forward-alt",
  "step-forward",
  "stop-circle",
  "stop",
  "stopwatch",
  "sun",
  "sync",
  "table",
  "tablet",
  "tags",
  "tag",
  "telegram",
  "th-large",
  "thumbs-down-fill",
  "thumbs-down",
  "thumbs-up-fill",
  "thumbs-up",
  "ticket",
  "times-circle",
  "times",
  "trash",
  "truck",
  "twitter",
  "undo",
  "unlock",
  "upload",
  "user-edit",
  "user-minus",
  "user-plus",
  "users",
  "user",
  "verified",
  "video",
  "vimeo",
  "volume-down",
  "volume-off",
  "volume-up",
  "wallet",
  "whatsapp",
  "wifi",
  "window-maximize",
  "window-minimize",
  "wrench",
  "youtube"
)

library(cascadeSelect)

folderHaskell <- list(
  list( # first folder
    name = "findPatterInFiles", icon = Icon("bi bi-folder-fill", color = "orange"),
    sub = list(
      list( # subfolder of the first folder
        name = "src", icon = Icon("bi bi-folder-fill", color = "orange"),
        subsub = list(
          list( # file
            fname = "GetAhaHTML.hs", icon = Icon("oi oi-haskell")
          ),
          list( # file
            fname = "GetGrepResults.hs", icon = Icon("oi oi-haskell")
          )
        )
      ),
      list( # subfolder of the first folder
        name = "src-exe", icon = Icon("bi bi-folder-fill", color = "orange"),
        subsub = list(
          list( # file
            fname = "Main.hs", icon = Icon("oi oi-haskell")
          )
        )
      ),
      list( # file in the first folder
        fname = "findPatternInFiles.cabal", icon = Icon("oi oi-cabal")
      ),
      list( # file in the first folder
        fname = "LICENSE", icon = Icon("oi oi-license")
      ),
      list( # file in the first folder
        fname = "README.md", icon = Icon("oi oi-markdown")
      ),
      list( # file in the first folder
        fname = "Setup.hs", icon = Icon("oi oi-haskell")
      ),
      list( # file in the first folder
        fname = "stack.yaml", icon = Icon("oi oi-yaml")
      ),
      list( # file in the first folder
        fname = ".gitignore", icon = Icon("bi bi-git")
      )
    )
  )
)

library(shiny)
library(cascadeSelect)

folderHaskell <- list(
  list( # first folder
    name = "findPatterInFiles", icon = Icon("bi bi-folder-fill", color = "orange"),
    sub = list(
      list( # subfolder of the first folder
        name = "src", icon = Icon("bi bi-folder-fill", color = "orange"),
        subsub = list(
          list( # file
            fname = "GetAhaHTML.hs", icon = Icon("oi oi-haskell")
          ),
          list( # file
            fname = "GetGrepResults.hs", icon = Icon("oi oi-haskell")
          )
        )
      ),
      list( # subfolder of the first folder
        name = "src-exe", icon = Icon("bi bi-folder-fill", color = "orange"),
        subsub = list(
          list( # file
            fname = "Main.hs", icon = Icon("oi oi-haskell")
          )
        )
      ),
      list( # file in the first folder
        fname = "findPatternInFiles.cabal", icon = Icon("oi oi-cabal")
      ),
      list( # file in the first folder
        fname = "LICENSE", icon = Icon("oi oi-license")
      ),
      list( # file in the first folder
        fname = "README.md", icon = Icon("oi oi-markdown")
      ),
      list( # file in the first folder
        fname = "Setup.hs", icon = Icon("oi oi-haskell")
      ),
      list( # file in the first folder
        fname = "stack.yaml", icon = Icon("oi oi-yaml")
      ),
      list( # file in the first folder
        fname = ".gitignore", icon = Icon("bi bi-git")
      )
    )
  )
)

ui <- fluidPage(
  titlePanel("My Haskell project"),
  fluidRow(
    column(
      6,
      cascadeSelectInput(
        "cascade",
        choices = folderHaskell,
        placeholder = "Select a file",
        optionLabel = "fname",
        optionGroupLabel = "name",
        optionGroupChildren = list("sub", "subsub"),
        theme = "luna-amber"
      ),
      br(),br(),
      textOutput("textOutput")
    )
  )
)

server <- function(input, output, session) {
  output[["textOutput"]] <- renderText({
    choice <- input[["cascade"]]
    sprintf(
      "You selected the file: %s.", dQuote(choice[["fname"]])
    )
  })
}

shinyApp(ui, server)

library(shiny)
library(cascadeSelect)

ui <- fluidPage(
  titlePanel("Cascade Select"),
  fluidRow(
    column(
      6,
      cascadeSelectInput(
        "textInput",
        choices = countries,
        placeholder = "Select a city",
        optionLabel = "cname",
        optionGroupLabel = "name",
        optionGroupChildren = list("states", "cities")
      ),
      br(),br(),
      textOutput("textOutput")
    )
  )
)

server <- function(input, output, session) {
  output$textOutput <- renderText({
    sprintf("You entered: %s", input$textInput)
  })

  observe(print(input$textInput))
}

shinyApp(ui, server)
